package com.hina.demo.controller;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.hina.demo.model.HookMessageReq;
import com.hina.demo.model.HookMessageRes;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/hina/webhook")
public class WebhookController {

    private static final Logger log = LoggerFactory.getLogger(WebhookController.class);

    @PostMapping("/receive")
    public List<HookMessageRes> receive(@RequestBody List<HookMessageReq> req) throws JsonProcessingException {
        log.info("请求 receive 参数 {}", new ObjectMapper().writeValueAsString(req));
        // TODO 业务处理
        List<HookMessageRes> result = new ArrayList<>();
        for (HookMessageReq hookMessageReq : req) {
            // 业务处理 - 获取您配置的用户属性
            Map<String, String> userProfile = hookMessageReq.getUser_profile();
            for (Map.Entry<String, String> entry : userProfile.entrySet()) {
                log.info("用户属性 {} {}", entry.getKey(), entry.getValue());
            }
            // 业务处理 - 获取您配置的动态参数
            Map<String, String> params = hookMessageReq.getParams();
            for (Map.Entry<String, String> entry : params.entrySet()) {
                log.info("动态参数 {} {}", entry.getKey(), entry.getValue());
            }
            // 结果封装
            HookMessageRes hookMessageRes = new HookMessageRes();
            hookMessageRes.setSucceed(true);
            result.add(hookMessageRes);
        }
        log.info("响应 receive 结果 {}", new ObjectMapper().writeValueAsString(result));
        return result;
    }
}
